#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n,x,k;

    cin>>n>>k>>x;

    vector<long long> a(n);
    vector<long long> psum(n);


    cin>>a[0];
    psum[0] = a[0];
    for(int i = 1;i<n;i++){
        cin>>a[i];
        psum[i] = psum[i-1] + a[0];
    }

    long long sum = 0;
    int c = 1;
    for(int j = 0;j<k;j++){
        sum += a[j]*c;
        if(c!=x){
            c++;
        }
    }
    cout<<sum<<' ';

    for(int i = 1;i<n-k+1;i++){

        if(i == 1){
            sum -= psum[i+k-1];
        }else{
            sum -= psum[i+k-1] - psum[i-1];
        }
        sum += c*a[i+k-1];
        cout<<sum<<' ';
    }



    return 0;
}